#!/usr/bin/perl

use strict;

require "wakautils.pl";
use Data::Dumper;
use Time::Local;


for(@ARGV)
{
	if(/\%2Fkareha\.pl\%2F([0-9]{10})\%2F\+/)
	{
		my $thread=$1;
		my @lines=read_array($_);
		my @posts;

		shift @lines while(@lines&&$lines[0]!~/^<!DOCTYPE/);
		next unless @lines;

		push @posts,shift @lines; # header
		push @posts,shift @lines while($lines[0]=~/^\s*<div class/);
		push @posts,shift @lines; # footer

		my ($title)=@posts[0]=~/<h2>([^<>]+)+?\s*</;
		my $permasage=@posts[0]=~/class="sage/?1:0;

		$posts[1]=~m!<span class="postername">([^<>]*)</span><span class="postertrip">([^<>]*)</span>!;
		my $author="$1$2";

		my $lastmod=$thread;
		my $lasthit=$thread;

		for(1..@posts-2)
		{
			if($posts[$_]=~m!(20[0-9]{2})-([0-1][0-9])-([0-3][0-9]) ([0-2][0-9]):([0-5][0-9]).*</h3>!)
			{
				my $timestamp=timegm(0,$5,$4,$3,$2-1,$1);
				$lastmod=$timestamp;
				$lasthit=$timestamp if $posts[$_]!~m!<a href="mailto:[^"]*sage[^"]*">!;
			}
		}

		my %meta=(
			closed=>0,
			lastmod=>$lastmod,
			lasthit=>$lasthit,
			title=>$title,
			author=>$author,
			permasage=>$permasage,
			postcount=>@posts-2,
		);

		$Data::Dumper::Terse=1;
		$Data::Dumper::Indent=0;
		unshift @posts,'<!-- '.Dumper(\%meta).' -->';

		if(-e "$thread.html")
		{
			my @other=read_array("$thread.html");
			my ($code)=$other[0]=~/\<!--(.*)--\>/;
			if($code)
			{
				my %othermeta=%{eval $code};
				if($othermeta{postcount}>$meta{postcount})
				{
					print "$thread: Older, skipped!\n";
					next;
				}
				elsif($othermeta{postcount}==$meta{postcount})
				{
					print "*";
				}
			}
		}

		print "$thread: $lasthit $lastmod $permasage $author $title\n";
		write_array("$thread.html",@posts);
	}
}
